/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:46:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.games.model;

/**
 * This is a JSON template for the iOS details resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class InstanceIosDetails extends com.google.api.client.json.GenericJson {

  /**
   * Bundle identifier.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String bundleIdentifier;

  /**
   * iTunes App ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String itunesAppId;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#instanceIosDetails.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Indicates that this instance is the default for new installations on iPad devices.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean preferredForIpad;

  /**
   * Indicates that this instance is the default for new installations on iPhone devices.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean preferredForIphone;

  /**
   * Flag to indicate if this instance supports iPad.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean supportIpad;

  /**
   * Flag to indicate if this instance supports iPhone.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean supportIphone;

  /**
   * Bundle identifier.
   * @return value or {@code null} for none
   */
  public java.lang.String getBundleIdentifier() {
    return bundleIdentifier;
  }

  /**
   * Bundle identifier.
   * @param bundleIdentifier bundleIdentifier or {@code null} for none
   */
  public InstanceIosDetails setBundleIdentifier(java.lang.String bundleIdentifier) {
    this.bundleIdentifier = bundleIdentifier;
    return this;
  }

  /**
   * iTunes App ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getItunesAppId() {
    return itunesAppId;
  }

  /**
   * iTunes App ID.
   * @param itunesAppId itunesAppId or {@code null} for none
   */
  public InstanceIosDetails setItunesAppId(java.lang.String itunesAppId) {
    this.itunesAppId = itunesAppId;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#instanceIosDetails.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#instanceIosDetails.
   * @param kind kind or {@code null} for none
   */
  public InstanceIosDetails setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Indicates that this instance is the default for new installations on iPad devices.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getPreferredForIpad() {
    return preferredForIpad;
  }

  /**
   * Indicates that this instance is the default for new installations on iPad devices.
   * @param preferredForIpad preferredForIpad or {@code null} for none
   */
  public InstanceIosDetails setPreferredForIpad(java.lang.Boolean preferredForIpad) {
    this.preferredForIpad = preferredForIpad;
    return this;
  }

  /**
   * Indicates that this instance is the default for new installations on iPhone devices.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getPreferredForIphone() {
    return preferredForIphone;
  }

  /**
   * Indicates that this instance is the default for new installations on iPhone devices.
   * @param preferredForIphone preferredForIphone or {@code null} for none
   */
  public InstanceIosDetails setPreferredForIphone(java.lang.Boolean preferredForIphone) {
    this.preferredForIphone = preferredForIphone;
    return this;
  }

  /**
   * Flag to indicate if this instance supports iPad.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getSupportIpad() {
    return supportIpad;
  }

  /**
   * Flag to indicate if this instance supports iPad.
   * @param supportIpad supportIpad or {@code null} for none
   */
  public InstanceIosDetails setSupportIpad(java.lang.Boolean supportIpad) {
    this.supportIpad = supportIpad;
    return this;
  }

  /**
   * Flag to indicate if this instance supports iPhone.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getSupportIphone() {
    return supportIphone;
  }

  /**
   * Flag to indicate if this instance supports iPhone.
   * @param supportIphone supportIphone or {@code null} for none
   */
  public InstanceIosDetails setSupportIphone(java.lang.Boolean supportIphone) {
    this.supportIphone = supportIphone;
    return this;
  }

  @Override
  public InstanceIosDetails set(String fieldName, Object value) {
    return (InstanceIosDetails) super.set(fieldName, value);
  }

  @Override
  public InstanceIosDetails clone() {
    return (InstanceIosDetails) super.clone();
  }

}
